package turingmachine;

import java.awt.*;

/**
 * The root application class for the turing machine simulator.
 */
public class CTMApplication
{
  /**
   * The application main frame.
   */
  private CTMFrame mFrame;

  /**
   * Constructor.
   */
  public CTMApplication()
  {
	mFrame = new CTMFrame();
	mFrame.validate();

	// Center the window
	Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
	Dimension frameSize = mFrame.getSize();
	if ( frameSize.height>screenSize.height )
	{
	  frameSize.height = screenSize.height;
	}
	if ( frameSize.width>screenSize.width )
	{
	  frameSize.width = screenSize.width;
	}

	mFrame.setLocation( ( screenSize.width-frameSize.width )/2,
		( screenSize.height-frameSize.height )/2 );
	mFrame.setVisible( true );
  }

  /**
   * Main method.
   *
   * @param args Command line arguments for application(There are none).<br>
   */
  public static void main( String[] args )
  {
	new CTMApplication();
  }
}
