package turingmachine;

import java.awt.*;
import java.awt.event.*;

import javax.swing.*;
import javax.swing.border.*;

/**
 * View of tape for turing machine execution.
 */
public class CTMInternalFrameTape
	extends JInternalFrame
{
  private Border border1 = BorderFactory.createEmptyBorder( 8, 8, 8, 8 );

  private JTextField jTextFieldTapeLeft = new JTextField();

  private JTextField jTextFieldTapeRight = new JTextField();

  private JLabel jLabelTapePosition = new JLabel();

  public CTMInternalFrameTape()
  {
	super( "Tape", true, false, false, false );

	try
	{
	  jbInit();
	}
	catch ( Exception ex )
	{
	  ex.printStackTrace();
	}

	setSize( 640, 80 );
	setVisible( true );

	jTextFieldTapeRight.addKeyListener( new KeyAdapter()
	{
	  public void keyTyped( java.awt.event.KeyEvent e )
	  {
		if ( e.getKeyCode()==KeyEvent.VK_LEFT )
		{
		  if ( jTextFieldTapeRight.getCaretPosition()==0 )
		  {
			jTextFieldTapeLeft.requestFocus();
			jTextFieldTapeLeft.setCaretPosition( jTextFieldTapeLeft
				.getText().length() );
		  }
		}
	  }
	} );
  }

  private void jbInit()
	  throws Exception
  {
	this.getContentPane().setLayout( new GridBagLayout() );
	this.setBorder( border1 );
	jLabelTapePosition.setFont( new java.awt.Font( "Monospaced", Font.BOLD,
		14 ) );
	jLabelTapePosition.setText( " ^" );
	jLabelTapePosition.setHorizontalAlignment( SwingConstants.CENTER );
	jTextFieldTapeLeft.setText( "11100" );
	jTextFieldTapeLeft.setHorizontalAlignment( SwingConstants.LEFT );
	jTextFieldTapeLeft.setFont( new java.awt.Font( "Monospaced", Font.BOLD,
		14 ) );
	jTextFieldTapeLeft.setBorder( null );
	jTextFieldTapeRight.setText( "11100" );
	jTextFieldTapeRight.setHorizontalAlignment( SwingConstants.RIGHT );
	jTextFieldTapeRight.setFont( new java.awt.Font( "Monospaced", Font.BOLD,
		14 ) );
	jTextFieldTapeRight.setBorder( null );
	this.getContentPane().add(
		jLabelTapePosition,
		new GridBagConstraints( 0, 1, 2, 1, 1.0, 0.0,
		GridBagConstraints.CENTER, GridBagConstraints.NONE,
		new Insets( 0, 0, 0, 0 ), 0, 0 ) );
	this.getContentPane().add(
		jTextFieldTapeLeft,
		new GridBagConstraints( 1, 0, 1, 1, 1.0, 0.0,
		GridBagConstraints.CENTER,
		GridBagConstraints.HORIZONTAL, new Insets( 0, 0, 0, 0 ),
		0, 0 ) );
	this.getContentPane().add(
		jTextFieldTapeRight,
		new GridBagConstraints( 0, 0, 1, 1, 1.0, 0.0,
		GridBagConstraints.CENTER,
		GridBagConstraints.HORIZONTAL, new Insets( 0, 0, 0, 0 ),
		0, 0 ) );
  }
}
