package turingmachine;

import java.awt.*;

import javax.swing.*;

/**
 * Generic place for utility functions.
 */
class CTMUtility
{
  /**
   * Create a custom cursor.
   *
   * @param aImageResource The name of the image resource to use.
   * @param aHotSpot The active point on the cursor.
   * @param aDescription Accesibility description.
   * @return The new cursor.
   */
  static Cursor createCursor( String aImageResource, Point aHotSpot,
	  String aDescription )
  {
	ImageIcon image = new ImageIcon( turingmachine.CTMFrame.class
					  .getResource( aImageResource ) );

	return Toolkit.getDefaultToolkit().createCustomCursor( image.getImage(),
		aHotSpot, aDescription );
  }

  /**
   * Centers a container to parent container.
   *
   * @param aContainer The container to center.
   */
  static void centerContainer( Container aContainer )
  {
	Dimension size = aContainer.getSize();
	Container aParentContainer = aContainer.getParent();
	Dimension parentSize = aParentContainer.getSize();
	Point parentLocation = aParentContainer.getLocationOnScreen();

	aContainer.setLocation( ( parentSize.width-size.width )/2
		+parentLocation.x, ( parentSize.height-size.height )/2
		+parentLocation.y );
  }
}
